# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['OrganizationArgs', 'Organization']

@pulumi.input_type
class OrganizationArgs:
    def __init__(__self__, *,
                 allowed_api_ip_addresses: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 enforce2fa: Optional[pulumi.Input[bool]] = None):
        """
        The set of arguments for constructing a Organization resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] allowed_api_ip_addresses: A list of IP addresses in CIDR format that are allowed to access the Buildkite API.If not set, all IP addresses are allowed (the same as setting 0.0.0.0/0).
        :param pulumi.Input[bool] enforce2fa: Sets whether the organization requires two-factor authentication for all members.
        """
        if allowed_api_ip_addresses is not None:
            pulumi.set(__self__, "allowed_api_ip_addresses", allowed_api_ip_addresses)
        if enforce2fa is not None:
            pulumi.set(__self__, "enforce2fa", enforce2fa)

    @property
    @pulumi.getter(name="allowedApiIpAddresses")
    def allowed_api_ip_addresses(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        A list of IP addresses in CIDR format that are allowed to access the Buildkite API.If not set, all IP addresses are allowed (the same as setting 0.0.0.0/0).
        """
        return pulumi.get(self, "allowed_api_ip_addresses")

    @allowed_api_ip_addresses.setter
    def allowed_api_ip_addresses(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "allowed_api_ip_addresses", value)

    @property
    @pulumi.getter
    def enforce2fa(self) -> Optional[pulumi.Input[bool]]:
        """
        Sets whether the organization requires two-factor authentication for all members.
        """
        return pulumi.get(self, "enforce2fa")

    @enforce2fa.setter
    def enforce2fa(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "enforce2fa", value)


@pulumi.input_type
class _OrganizationState:
    def __init__(__self__, *,
                 allowed_api_ip_addresses: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 enforce2fa: Optional[pulumi.Input[bool]] = None,
                 uuid: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering Organization resources.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] allowed_api_ip_addresses: A list of IP addresses in CIDR format that are allowed to access the Buildkite API.If not set, all IP addresses are allowed (the same as setting 0.0.0.0/0).
        :param pulumi.Input[bool] enforce2fa: Sets whether the organization requires two-factor authentication for all members.
        :param pulumi.Input[str] uuid: The UUID of the organization.
        """
        if allowed_api_ip_addresses is not None:
            pulumi.set(__self__, "allowed_api_ip_addresses", allowed_api_ip_addresses)
        if enforce2fa is not None:
            pulumi.set(__self__, "enforce2fa", enforce2fa)
        if uuid is not None:
            pulumi.set(__self__, "uuid", uuid)

    @property
    @pulumi.getter(name="allowedApiIpAddresses")
    def allowed_api_ip_addresses(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        A list of IP addresses in CIDR format that are allowed to access the Buildkite API.If not set, all IP addresses are allowed (the same as setting 0.0.0.0/0).
        """
        return pulumi.get(self, "allowed_api_ip_addresses")

    @allowed_api_ip_addresses.setter
    def allowed_api_ip_addresses(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "allowed_api_ip_addresses", value)

    @property
    @pulumi.getter
    def enforce2fa(self) -> Optional[pulumi.Input[bool]]:
        """
        Sets whether the organization requires two-factor authentication for all members.
        """
        return pulumi.get(self, "enforce2fa")

    @enforce2fa.setter
    def enforce2fa(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "enforce2fa", value)

    @property
    @pulumi.getter
    def uuid(self) -> Optional[pulumi.Input[str]]:
        """
        The UUID of the organization.
        """
        return pulumi.get(self, "uuid")

    @uuid.setter
    def uuid(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "uuid", value)


class Organization(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 allowed_api_ip_addresses: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 enforce2fa: Optional[pulumi.Input[bool]] = None,
                 __props__=None):
        """
        This resource allows you to manage the settings for an organization.

        The user of your API token must be an organization administrator to manage organization settings.

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import pulumiverse_buildkite as buildkite

        # allow api access only from 1.1.1.1 and enforce 2fa for all members
        settings = buildkite.organization.Organization("settings",
            allowed_api_ip_addresses=["1.1.1.1/32"],
            enforce2fa=True)
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        import the organization settings via the organization slug

        ```sh
        $ pulumi import buildkite:Organization/organization:Organization settings <organization slug>
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] allowed_api_ip_addresses: A list of IP addresses in CIDR format that are allowed to access the Buildkite API.If not set, all IP addresses are allowed (the same as setting 0.0.0.0/0).
        :param pulumi.Input[bool] enforce2fa: Sets whether the organization requires two-factor authentication for all members.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[OrganizationArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        This resource allows you to manage the settings for an organization.

        The user of your API token must be an organization administrator to manage organization settings.

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import pulumiverse_buildkite as buildkite

        # allow api access only from 1.1.1.1 and enforce 2fa for all members
        settings = buildkite.organization.Organization("settings",
            allowed_api_ip_addresses=["1.1.1.1/32"],
            enforce2fa=True)
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        import the organization settings via the organization slug

        ```sh
        $ pulumi import buildkite:Organization/organization:Organization settings <organization slug>
        ```

        :param str resource_name: The name of the resource.
        :param OrganizationArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(OrganizationArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 allowed_api_ip_addresses: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 enforce2fa: Optional[pulumi.Input[bool]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = OrganizationArgs.__new__(OrganizationArgs)

            __props__.__dict__["allowed_api_ip_addresses"] = allowed_api_ip_addresses
            __props__.__dict__["enforce2fa"] = enforce2fa
            __props__.__dict__["uuid"] = None
        super(Organization, __self__).__init__(
            'buildkite:Organization/organization:Organization',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            allowed_api_ip_addresses: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            enforce2fa: Optional[pulumi.Input[bool]] = None,
            uuid: Optional[pulumi.Input[str]] = None) -> 'Organization':
        """
        Get an existing Organization resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] allowed_api_ip_addresses: A list of IP addresses in CIDR format that are allowed to access the Buildkite API.If not set, all IP addresses are allowed (the same as setting 0.0.0.0/0).
        :param pulumi.Input[bool] enforce2fa: Sets whether the organization requires two-factor authentication for all members.
        :param pulumi.Input[str] uuid: The UUID of the organization.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _OrganizationState.__new__(_OrganizationState)

        __props__.__dict__["allowed_api_ip_addresses"] = allowed_api_ip_addresses
        __props__.__dict__["enforce2fa"] = enforce2fa
        __props__.__dict__["uuid"] = uuid
        return Organization(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="allowedApiIpAddresses")
    def allowed_api_ip_addresses(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        A list of IP addresses in CIDR format that are allowed to access the Buildkite API.If not set, all IP addresses are allowed (the same as setting 0.0.0.0/0).
        """
        return pulumi.get(self, "allowed_api_ip_addresses")

    @property
    @pulumi.getter
    def enforce2fa(self) -> pulumi.Output[bool]:
        """
        Sets whether the organization requires two-factor authentication for all members.
        """
        return pulumi.get(self, "enforce2fa")

    @property
    @pulumi.getter
    def uuid(self) -> pulumi.Output[str]:
        """
        The UUID of the organization.
        """
        return pulumi.get(self, "uuid")

