# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'GetTeamResult',
    'AwaitableGetTeamResult',
    'get_team',
    'get_team_output',
]

@pulumi.output_type
class GetTeamResult:
    """
    A collection of values returned by getTeam.
    """
    def __init__(__self__, default_member_role=None, default_team=None, description=None, id=None, members_can_create_pipelines=None, name=None, privacy=None, slug=None, uuid=None):
        if default_member_role and not isinstance(default_member_role, str):
            raise TypeError("Expected argument 'default_member_role' to be a str")
        pulumi.set(__self__, "default_member_role", default_member_role)
        if default_team and not isinstance(default_team, bool):
            raise TypeError("Expected argument 'default_team' to be a bool")
        pulumi.set(__self__, "default_team", default_team)
        if description and not isinstance(description, str):
            raise TypeError("Expected argument 'description' to be a str")
        pulumi.set(__self__, "description", description)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if members_can_create_pipelines and not isinstance(members_can_create_pipelines, bool):
            raise TypeError("Expected argument 'members_can_create_pipelines' to be a bool")
        pulumi.set(__self__, "members_can_create_pipelines", members_can_create_pipelines)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if privacy and not isinstance(privacy, str):
            raise TypeError("Expected argument 'privacy' to be a str")
        pulumi.set(__self__, "privacy", privacy)
        if slug and not isinstance(slug, str):
            raise TypeError("Expected argument 'slug' to be a str")
        pulumi.set(__self__, "slug", slug)
        if uuid and not isinstance(uuid, str):
            raise TypeError("Expected argument 'uuid' to be a str")
        pulumi.set(__self__, "uuid", uuid)

    @property
    @pulumi.getter(name="defaultMemberRole")
    def default_member_role(self) -> str:
        """
        The default member role of the team.
        """
        return pulumi.get(self, "default_member_role")

    @property
    @pulumi.getter(name="defaultTeam")
    def default_team(self) -> bool:
        """
        Whether the team is the default team.
        """
        return pulumi.get(self, "default_team")

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        The description of the team.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The GraphQL ID of the team to find.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="membersCanCreatePipelines")
    def members_can_create_pipelines(self) -> bool:
        """
        Whether members can create pipelines.
        """
        return pulumi.get(self, "members_can_create_pipelines")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The name of the team.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def privacy(self) -> str:
        """
        The privacy setting of the team.
        """
        return pulumi.get(self, "privacy")

    @property
    @pulumi.getter
    def slug(self) -> str:
        """
        The slug of the team to find.
        """
        return pulumi.get(self, "slug")

    @property
    @pulumi.getter
    def uuid(self) -> str:
        """
        The UUID of the team.
        """
        return pulumi.get(self, "uuid")


class AwaitableGetTeamResult(GetTeamResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetTeamResult(
            default_member_role=self.default_member_role,
            default_team=self.default_team,
            description=self.description,
            id=self.id,
            members_can_create_pipelines=self.members_can_create_pipelines,
            name=self.name,
            privacy=self.privacy,
            slug=self.slug,
            uuid=self.uuid)


def get_team(id: Optional[str] = None,
             slug: Optional[str] = None,
             opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetTeamResult:
    """
    Use this data source to retrieve a team by slug or id. You can find out more about teams in the Buildkite
    [documentation](https://buildkite.com/docs/pipelines/permissions).

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_buildkite as buildkite

    team_dev = buildkite.Team.get_team(id=buildkite_team["team_dev"]["id"])
    team = buildkite.Team.get_team(slug="Everyone")
    ```
    <!--End PulumiCodeChooser -->


    :param str id: The GraphQL ID of the team to find.
    :param str slug: The slug of the team to find.
    """
    __args__ = dict()
    __args__['id'] = id
    __args__['slug'] = slug
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('buildkite:Team/getTeam:getTeam', __args__, opts=opts, typ=GetTeamResult).value

    return AwaitableGetTeamResult(
        default_member_role=pulumi.get(__ret__, 'default_member_role'),
        default_team=pulumi.get(__ret__, 'default_team'),
        description=pulumi.get(__ret__, 'description'),
        id=pulumi.get(__ret__, 'id'),
        members_can_create_pipelines=pulumi.get(__ret__, 'members_can_create_pipelines'),
        name=pulumi.get(__ret__, 'name'),
        privacy=pulumi.get(__ret__, 'privacy'),
        slug=pulumi.get(__ret__, 'slug'),
        uuid=pulumi.get(__ret__, 'uuid'))


@_utilities.lift_output_func(get_team)
def get_team_output(id: Optional[pulumi.Input[Optional[str]]] = None,
                    slug: Optional[pulumi.Input[Optional[str]]] = None,
                    opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetTeamResult]:
    """
    Use this data source to retrieve a team by slug or id. You can find out more about teams in the Buildkite
    [documentation](https://buildkite.com/docs/pipelines/permissions).

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_buildkite as buildkite

    team_dev = buildkite.Team.get_team(id=buildkite_team["team_dev"]["id"])
    team = buildkite.Team.get_team(slug="Everyone")
    ```
    <!--End PulumiCodeChooser -->


    :param str id: The GraphQL ID of the team to find.
    :param str slug: The slug of the team to find.
    """
    ...
